/*
 * Decompiled with CFR 0.152.
 */
package com.jiuqi.util;

import java.util.ArrayList;

public class Matrix {
    private int colCount = 0;
    private int rowCount = 0;
    private ArrayList rowList = new ArrayList(0);

    public Matrix() {
    }

    public Matrix(int colCount, int rowCount) {
        this.reset(colCount, rowCount);
    }

    public void clear() {
        this.rowList.clear();
        this.colCount = 0;
        this.rowCount = 0;
    }

    public void reset(int newColCount, int newRowCount) {
        this.clear();
        this.setColCount(newColCount);
        this.setRowCount(newRowCount);
    }

    public final int getColCount() {
        return this.colCount;
    }

    public final void setColCount(int newColCount) {
        if (this.colCount == newColCount) {
            return;
        }
        int count = this.colCount <= newColCount ? this.colCount : newColCount;
        int i = 0;
        while (i < this.rowCount) {
            Object[] oldRow = (Object[])this.rowList.get(i);
            if (oldRow != null) {
                Object[] newRow = new Object[newColCount];
                int j = 0;
                while (j < count) {
                    newRow[j] = oldRow[j];
                    ++j;
                }
                this.rowList.set(i, newRow);
            }
            ++i;
        }
        this.colCount = newColCount;
    }

    public final int getRowCount() {
        return this.rowCount;
    }

    public final void setRowCount(int newRowCount) {
        if (this.rowCount == newRowCount) {
            return;
        }
        int i = this.rowCount - 1;
        while (i >= newRowCount) {
            this.rowList.remove(i);
            --i;
        }
        i = this.rowCount;
        while (i < newRowCount) {
            this.rowList.add(null);
            ++i;
        }
        this.rowCount = newRowCount;
    }

    public final Object getItem(int col, int row) {
        Object[] aRow = (Object[])this.rowList.get(row);
        return aRow == null ? null : aRow[col];
    }

    public final void setItem(int col, int row, Object value) {
        Object[] aRow = (Object[])this.rowList.get(row);
        if (aRow == null) {
            if (value == null) {
                return;
            }
            aRow = new Object[this.colCount];
            this.rowList.set(row, aRow);
        }
        aRow[col] = value;
    }

    public final void insertCol(int index) {
        int i = 0;
        while (i < this.rowCount) {
            Object[] oldRow = (Object[])this.rowList.get(i);
            if (oldRow != null) {
                Object[] newRow = new Object[this.colCount + 1];
                int j = 0;
                while (j < index) {
                    newRow[j] = oldRow[j];
                    ++j;
                }
                j = index;
                while (j < this.colCount) {
                    newRow[j + 1] = oldRow[j];
                    ++j;
                }
                this.rowList.set(i, newRow);
            }
            ++i;
        }
        ++this.colCount;
    }

    public final void insertCol(int index, int count) {
        int i = 0;
        while (i < this.rowCount) {
            Object[] oldRow = (Object[])this.rowList.get(i);
            if (oldRow != null) {
                Object[] newRow = new Object[this.colCount + count];
                int j = 0;
                while (j < index) {
                    newRow[j] = oldRow[j];
                    ++j;
                }
                j = index;
                while (j < this.colCount) {
                    newRow[j + count] = oldRow[j];
                    ++j;
                }
                this.rowList.set(i, newRow);
            }
            ++i;
        }
        this.colCount += count;
    }

    public final void insertCol(int index, int count, Object[] rowItems) {
        this.insertCol(index, count);
        if (rowItems == null || rowItems.length == 0) {
            return;
        }
        int len = Math.min(this.rowCount, rowItems.length);
        if (len == 0) {
            return;
        }
        int i = 0;
        while (i < count) {
            int row = 0;
            while (row < len) {
                this.setItem(index + i, row, rowItems[row]);
                ++row;
            }
            ++i;
        }
    }

    public final void duplicateCol(int index, int count) {
        int i = 0;
        while (i < this.rowCount) {
            Object[] oldRow = (Object[])this.rowList.get(i);
            if (oldRow != null) {
                Object[] newRow = new Object[this.colCount + count];
                int j = 0;
                while (j <= index) {
                    newRow[j] = oldRow[j];
                    ++j;
                }
                j = 1;
                while (j <= count) {
                    newRow[index + j] = oldRow[index];
                    ++j;
                }
                j = index + 1;
                while (j < this.colCount) {
                    newRow[j + count] = oldRow[j];
                    ++j;
                }
                this.rowList.set(i, newRow);
            }
            ++i;
        }
        this.colCount += count;
    }

    public final void deleteCol(int index) {
        int i = 0;
        while (i < this.rowCount) {
            Object[] oldRow = (Object[])this.rowList.get(i);
            if (oldRow != null) {
                Object[] newRow = new Object[this.colCount - 1];
                int j = 0;
                while (j < index) {
                    newRow[j] = oldRow[j];
                    ++j;
                }
                j = index + 1;
                while (j < this.colCount) {
                    newRow[j - 1] = oldRow[j];
                    ++j;
                }
                this.rowList.set(i, newRow);
            }
            ++i;
        }
        --this.colCount;
    }

    public final void deleteCol(int index, int count) {
        int c = index + count > this.colCount ? this.colCount - index : count;
        int i = 0;
        while (i < this.rowCount) {
            Object[] oldRow = (Object[])this.rowList.get(i);
            if (oldRow != null) {
                Object[] newRow = new Object[this.colCount - 1];
                int j = 0;
                while (j < index) {
                    newRow[j] = oldRow[j];
                    ++j;
                }
                j = index + c;
                while (j < this.colCount) {
                    newRow[j - c] = oldRow[j];
                    ++j;
                }
                this.rowList.set(i, newRow);
            }
            ++i;
        }
        this.colCount -= c;
    }

    public final void exchangeCol(int index1, int index2) {
        int i = 0;
        while (i < this.rowCount) {
            Object[] aRow = (Object[])this.rowList.get(i);
            Object T = aRow[index1];
            aRow[index1] = aRow[index2];
            aRow[index2] = T;
            ++i;
        }
    }

    public final void moveCol(int index1, int index2) {
        if (index1 == index2) {
            return;
        }
        int i = 0;
        while (i < this.rowCount) {
            Object[] aRow = (Object[])this.rowList.get(i);
            if (aRow != null) {
                int j;
                Object T = aRow[index1];
                if (index1 > index2) {
                    j = index1 - 1;
                    while (j >= index2) {
                        aRow[j + 1] = aRow[j];
                        --j;
                    }
                } else if (index1 < index2) {
                    j = index1 + 1;
                    while (j < index2) {
                        aRow[j - 1] = aRow[j];
                        ++j;
                    }
                }
                aRow[index2] = T;
            }
            ++i;
        }
    }

    public final void insertRow(int index) {
        this.rowList.add(index, null);
        ++this.rowCount;
    }

    public final void insertRow(int index, int count) {
        int i = 0;
        while (i < count) {
            this.rowList.add(index, null);
            ++i;
        }
        this.rowCount += count;
    }

    public final void insertRow(int index, int count, Object[] colItems) {
        if (colItems == null || colItems.length == 0) {
            this.insertRow(index, count);
            return;
        }
        int len = Math.min(this.colCount, colItems.length);
        int i = 0;
        while (i < count) {
            Object[] newRow = new Object[this.colCount];
            int j = 0;
            while (j < len) {
                newRow[j] = colItems[j];
                ++j;
            }
            this.rowList.add(index, newRow);
            ++i;
        }
        this.rowCount += count;
    }

    public final void duplicateRow(int index, int count) {
        int i = 0;
        while (i < count) {
            Object[] oldRow = (Object[])this.rowList.get(index);
            Object[] newRow = null;
            if (oldRow != null) {
                newRow = new Object[this.colCount];
                int j = 0;
                while (j < this.colCount) {
                    newRow[j] = oldRow[j];
                    ++j;
                }
            }
            this.rowList.add(index + 1, newRow);
            ++i;
        }
        this.rowCount += count;
    }

    public final void deleteRow(int index) {
        this.rowList.remove(index);
        --this.rowCount;
    }

    public final void deleteRow(int index, int count) {
        int c = index + count > this.rowCount ? this.rowCount - index : count;
        int row = index + c - 1;
        while (row >= index) {
            this.rowList.remove(row);
            --row;
        }
        this.rowCount -= c;
    }

    public final void exchangeRow(int index1, int index2) {
        Object[] aRow = (Object[])this.rowList.get(index1);
        this.rowList.set(index1, this.rowList.get(index2));
        this.rowList.set(index2, aRow);
    }

    public final void moveRow(int index1, int index2) {
        Object[] aRow = (Object[])this.rowList.get(index1);
        if (index1 > index2) {
            int i = index1 - 1;
            while (i >= index2) {
                this.rowList.set(i + 1, this.rowList.get(i));
                --i;
            }
        } else if (index1 < index2) {
            int i = index1 + 1;
            while (i < index2) {
                this.rowList.set(i - 1, this.rowList.get(i));
                ++i;
            }
        }
        this.rowList.set(index2, aRow);
    }
}

